program Graph_23a;
{
  P-
}
{$APPTYPE CONSOLE}

uses
  SysUtils,
  DateUtils,
  Assembly in '..\Common\Assembly.pas',
  Graph in '..\Common\Graph.pas',
  GrChars in '..\Common\GrChars.pas',
  Items in '..\Common\Items.pas',
  Root in '..\Common\Root.pas',
  SetList in '..\Common\SetList.pas',
  SetUtils in '..\Common\SetUtils.pas';

type  TGrTest = class(TGraphChars)
        function GenCombin1(aSize: integer): TBuffer;
        function GenCombin2(aSize: integer): TBuffer;
        function GenCombin3(aSize: integer): TBuffer;
      end;

var Gr: TGrTest;
    Res: TBuffer;

{ TGrTest }
//////////////////////////////////////////////////////////////

function TGrTest.GenCombin1(aSize: integer): TBuffer;

var S: TSet;

  procedure Local(aN: integer; aSet: TSet);
  var i: integer;
  begin
    //   
    for i:= aN+1 to mNodes.GetCount do begin
      S:= aSet.Copy as TSet;
      S.Insert(mNodes.GetItem(i));
      if S.GetCount >= aSize //   ?
        then Result.Push(S)
        else Local(i, S);
    end;
    aSet.Free;   //  -   
  end;

begin
  Result:= TBuffer.Create;
  S:= CreateSet;
  Local(0, S);
end;
//////////////////////////////////////////////////////////////

function TGrTest.GenCombin2(aSize: integer): TBuffer;
var
    S: TSet;
    N: integer;
    Level : integer;

  procedure Local(aIndex: integer);
  var i: integer;
      t: TItem;
  begin
    Inc(Level);
    for i:= aIndex to N do begin
      t:= mNodes.GetItem(i + Level - 1);
      S.Insert(t);
      if Level=aSize then begin
        Result.Push(S.Copy);
      end else begin
        Local(i);
      end;
      S.Delete(t);
    end;
    Dec(Level);
  end;

begin
  Result:= TBuffer.Create;
  S:= CreateSet;
  N:= mNodes.GetCount + 1 - aSize;
  Level:= 0;
  Local(1);
  S.Free;
end;
//////////////////////////////////////////////////////////////

function TGrTest.GenCombin3(aSize: integer): TBuffer;
var
    S: TSet;
    N: integer;
    Level : integer;
    t: TItem;

  procedure Local(aIndex: integer);
  var i: integer;
  begin
    Inc(Level);
    for i:= aIndex to N do begin
      //if not Assigned(t) then Break;
      S.Insert(t);
      if Level=aSize then begin
        Result.Push(S.Copy);
      end else begin
        PosPush;
        Local(i);
        PosPop;
      end;
      S.Delete(t);
      t:= NodeNext;
    end;
    (*
    for i:= aIndex to N do begin
      t:= mNodes.GetItem(i + Level - 1);
      S.Insert(t);
      if Level=aSize then begin
        Result.Push(S.Copy);
      end else begin
        Local(i);
      end;
      S.Delete(t);
    end;
    *)
    Dec(Level);
  end;

begin
  Result:= TBuffer.Create;
  S:= CreateSet;
  N:= mNodes.GetCount + 1 - aSize;
  Level:= 0;
  t:= NodeFirst;
  Local(1);
  S.Free;
end;
//////////////////////////////////////////////////////////////

const C= 1000;

var S: string;
    i: integer;
    Start : TDateTime;


begin
  try
    //Gr:= TGraphChars.Load('Test_1.txt') as TGrTest;
    //Gr:= TGraphChars.GenRandom(false, 10, 10, 5, 12);
    Gr:= TGrTest.GenRandom(false, 10, 10, 18, 22);
    Gr.Expo;
    Writeln('- - - - - - - - - - - - - - - - - -');
    repeat

      Start:= Now;
      for i:= 1 to C do begin
        Res:= Gr.GenCombin1(5);
        Res.ClrAndDestroy;
        Res.Free;
      end;
      Writeln ('1= ', MilliSecondsBetween(Start, Now));

      Start:= Now;
      for i:= 1 to C do begin
        Res:= Gr.GenCombin2(5);
        Res.ClrAndDestroy;
        Res.Free;
      end;
      Writeln ('2= ', MilliSecondsBetween(Start, Now));

      Start:= Now;
      for i:= 1 to C do begin
        Res:= Gr.GenCombin3(5);
        Res.ClrAndDestroy;
        Res.Free;
      end;
      Writeln ('3= ', MilliSecondsBetween(Start, Now));
      //Res.Expo;
      Writeln('- - - - - - - - - - - - - - - - - -');
      Write('S= '); Readln(S);
    until S<>'';
  except
    on E:Exception do
      Writeln(E.Classname, ': ', E.Message);
  end;
end.
